unable to create solid by lofting

Post here for help on using FreeCAD's graphical user interface (GUI).
Forum rules
and Helpful information
IMPORTANT: Please click here and read this first, before asking for help

Also, be nice to others! Read the FreeCAD code of conduct!
TheMarkster
Veteran
Posts: 5513
Joined: Thu Apr 05, 2018 1:53 am

Re: unable to create solid by lofting

Post by TheMarkster »

Okay. This one was more challenging to make. First step was to Part -> Loft all the wires (just the ones without faces) with only Ruled Surfaces checked in the dialog (not solid or closed). This creates a nice shell, but with the end sections still open. The next step is very tedious -- creating ruled surfaces from all the segments for each end (208 edges per end). I did the first 2 pairs (104 pairs per end) manually, then used a variation on this script to automate the process for each end:

Code: Select all

import FreeCAD

for ii in range(2,205):
    s1 = 'Wire023_child'+str(ii)
    s2 = 'Wire023_child'+str(205-(ii-2))
    if ii==103:
        break

    FreeCAD.ActiveDocument.addObject('Part::RuledSurface', 'Ruled Surface')
    FreeCAD.ActiveDocument.ActiveObject.Curve1=(getattr(FreeCAD.ActiveDocument,s2),['Edge1'])
    FreeCAD.ActiveDocument.ActiveObject.Curve2=(getattr(FreeCAD.ActiveDocument,s1),['Edge1'])
The reason for 'Wire023_child208', etc. is I downgraded the end wires in Draft workbench, then exploded the compound using Part -> Compound -> Explode compound. I'm not sure if those steps were completely necessary.

Even with the script I still ended up missing a couple ruled surfaces, but I was able to recreate them by manually. I think probably the line if ii==103 should maybe have been if ii==104, but I'm not sure. In any case now with all the ruled surfaces in place, use the Part -> Advanced utility to create shapes tool to make a shell from all the 2496 faces. Luckily there is an option in the dial to use all faces, which helps in the selection process, but there were still the ruled surfaces on the ends to select by hand. With the shell successfully created, next step is to use Part -> Convert to solid to turn the shell into a solid.

Hopefully all of this is as clear as mud. I had to delete all the history to make the file small enough for the forum. There are probably some tools in the Curves workbench that would have made this much easier, but I'm not familiar enough with them.
Attachments
marine_blade_ruled_surfaces_scr.png
marine_blade_ruled_surfaces_scr.png (89.77 KiB) Viewed 206 times
marine_blade_solid_ruled_surfaces.FCStd
(745.13 KiB) Downloaded 9 times
User avatar
hammax
Veteran
Posts: 1991
Joined: Thu Jan 19, 2017 5:03 pm
Location: Ammersee DE

Re: unable to create solid by lofting

Post by hammax »

… the more KISS and old fashioned approach to blade construction by Sketcher BSpline.
Variable Masterprofile => only 4 copies and z-placement.
Twisting done by velocity triangles (here only by eye).
S_Prop_3.PNG
S_Prop_3.PNG (99.45 KiB) Viewed 191 times
You also can do Common-"Cuts" with a variable R-Cylinder and look at the now cylindrical profile.
S_Prop_4.PNG
S_Prop_4.PNG (64.56 KiB) Viewed 178 times
Attachments
S_Prop_3.FCStd
(27.89 KiB) Downloaded 9 times
ninoleum
Posts: 6
Joined: Wed Jun 26, 2019 9:32 pm

Re: unable to create solid by lofting

Post by ninoleum »

I think the path you shown TheMarkster, is the right one.
You inspired me a modification of my initial script so that the small and narrow faces you created half manually on the bent wire can be added automatically.
Thank you for your time.
Gian Luca Rocchi
Post Reply